_showStress		= false;
_showVolume		= false;
_showWeather	= false;
_showMood		= false;
_showImage		= false;
_showTitle		= false;
_showAlbum		= false;
_showArtist		= false;
_showLength		= false;
_showTime		= false;	// Is not compensated by time acceleration

// ================================================================================================
_stress	= vehicle player getVariable "stress";

if (_showStress || _showVolume || _showWeather || _showMood || _showImage || _showTitle || _showAlbum || _showArtist || _showLength || _showTime) then
{
	_counter		= 1;
	_arrayString	= "<t size='2' shadow='1'>MoodJukebox</t><br/>";
	_formatArray	= "[_arrayString]";
	_image			= "";
	_title			= "";
	_album			= "";
	_artist			= "";
	_length			= getNumber (configFile >> "CfgMusic" >> MJBtrack >> "duration");
	_color			= "";

	if (_showStress) then
	{
		if (_stress >= middleStress) then {_color = " color='#ff0000'"} else {_color = ""};
		_arrayString	= _arrayString + format["<br/><t align='left'>stress: <t%3>%1%2</t></t>", "%", _counter, _color];
		_formatArray	= _formatArray + " + [_stress]";
		_counter		= _counter + 1;
		MJBswitched		= true;	// Just to maintain other info on display
	};

	if (_showVolume) then
	{
		_arrayString	= _arrayString + format["<br/><t align='left'>volume: %1%2</t>", "%", _counter];
		_formatArray	= _formatArray + " + [musicVolume]";
		_counter		= _counter + 1;
		MJBswitched		= true;
	};

	if (_showWeather) then
	{
		_weathers	= [["daytime", !MJBday], ["overcast", MJBclouds], ["rain", MJBrain], ["fog", MJBfog]];
		_countWeather	= 0;
		{
			if ((_weathers select _countWeather) select 1) then {_color = " color='#ff0000'"} else {_color = ""};
			// "mood: %1<br/>_x: %2<br/>"
			_arrayString	= _arrayString + format["<br/><t align='left'>%1: <t%4>%2%3</t></t>", (_weathers select _countWeather) select 0, "%", _counter, _color];
			// "[_arrayString] + [playerMood] + [overcast]"
			_formatArray	= _formatArray + " + [" + ((_weathers select _countWeather) select 0) + "]";
			_counter		= _counter + 1;
			_countWeather	= _countWeather +1;
		} forEach _weathers;
		MJBswitched		= true;
	};

	if (_showTime) then {MJBswitched = true};

	// Non-continuous updated information
	if (MJBswitched) then
	{
		if (_showMood) then
		{
			_arrayString	= _arrayString + format["<br/><t align='left'>mood: %1%2</t>", "%", _counter]; // "mood: %1<br/>"
			_formatArray	= _formatArray + " + [playerMood]"; // "[_arrayString] + [playerMood]"
			_counter		= _counter + 1;
		};

		if (_showImage) then
		{
			_image			= getText (configFile >> "CfgMusic" >> MJBtrack >> "image");
			_arrayString	= _arrayString + format["<br/><img align='center' size='4' image='%1%2'/>", "%", _counter];
			_formatArray	= _formatArray + " + [_image]";
			_counter		= _counter + 1;
		};

		if (_showTitle) then
		{
			_title			= getText (configFile >> "CfgMusic" >> MJBtrack >> "name");
			_arrayString	= _arrayString + format["<br/><t align='left'>title: %1%2</t>", "%", _counter];
			_formatArray	= _formatArray + " + [_title]";
			_counter		= _counter + 1;
		};

		if (_showAlbum) then
		{
			_album			= getText (configFile >> "CfgMusic" >> MJBtrack >> "album");
			_arrayString	= _arrayString + format["<br/><t align='left'>album: %1%2</t>", "%", _counter];
			_formatArray	= _formatArray + " + [_album]";
			_counter		= _counter + 1;
		};

		if (_showArtist) then
		{
			_artist			= getText (configFile >> "CfgMusic" >> MJBtrack >> "artist");
			_arrayString	= _arrayString + format["<br/><t align='left'>artist: %1%2</t>", "%", _counter];
			_formatArray	= _formatArray + " + [_artist]";
			_counter		= _counter + 1;
		};

		if (_showLength) then
		{
			_arrayString	= _arrayString + format["<br/><t align='left'>length: %1%2 secs</t>", "%", _counter];
			_formatArray	= _formatArray + " + [_length]";
			_counter		= _counter + 1;
		};
	};

	if (_showTime) then
	{
		_length = getNumber (configFile >> "CfgMusic" >> MJBtrack >> "duration");
		_arrayString	= _arrayString + format["<br/><t align='left'>time: %1%2</t>", "%", _counter];
		_formatArray	= _formatArray + " + [MJBtime]";
		_counter		= _counter + 1;
		MJBswitched		= true;
	};

	// Displays info
	if (_counter > 1) then
	{
		_arrayString	= _arrayString + "<br/><br/><t align='right' font='Zeppelin33Italic' size='0.5'>by Scifer</t>";
		_formatArray = call compile _formatArray; // "call compile" turns the string into array
		hintSilent parseText format _formatArray;
	};
};