/* ======================================== Arma 2 MoodJukebox ================================================

This script dynamically selects the most appropriate mood in an unlimited number of summed music packs, adjust
its volume and plays its mood random music. All according to player's stress level, engagement and weather.
This is a very powerful script/addon which can dynamically turn the silent Arma2 into a completely musical game

Exemple:
nul = ["oa", "your-pack"] execVM "scripts\MoodJukebox\music.sqf";

																								By Scifer
*/

// Prevents two scripts from running in parallel
if (isNil "MJBon") then {MJBon = false};
if (MJBon) exitWith {};
MJBon = true;

// ======================================== Resume ===============================================
// Execute pause and loadgame detecting script
//(findDisplay 46) displayAddEventHandler ["KeyDown","if ((_this select 1)==1) then {player sidechat 'Esc key pressed!'}"];
if (isNil "MJBresume") then {MJBresume = [] execVM "scripts\MoodJukebox\resume.sqf"};
MJBpaused = false;

// ===============================================================================================

// Initial parameters
_lastMood		= "whatever";
_lastPlay		= -1000;
_duration		= -1000;
_lastTrack		= "";
_resumeTime		= 0;
MJBtrack		= "";
sadTrack		= "";
_volume			= 0.5;
		
// ===================================== Defining playlists =======================================
_playlist		= [];
_truceList		= [];
_darkList		= [];
_tensionList	= [];
_sadList		= [];
for [{_i = 0}, {_i	< (count (configFile >> "CfgMusic"))}, {_i = _i + 1}] do
{
	_newClass	= (configFile >> "CfgMusic") select _i;
	if (isClass _newClass) then
	{
		_pack	= getText (_newClass >> "pack");
		if (_pack in _this) then
		{
			_addTrack	= configName _newClass;
			_moodArray	= getArray (_newClass >> "moods");
			{
				switch _x do
				{
					case "truce":		{_truceList		= _truceList	+ [_addTrack]};
					case "darkness":	{_darkList		= _darkList		+ [_addTrack]};
					case "tension":		{_tensionList	= _tensionList	+ [_addTrack]};
					case "sadness":		{_sadList		= _sadList		+ [_addTrack]};
				};
			} forEach _moodArray;
		};
	};
};

// ===============================================================================================

// Main
while {count switchableUnits > 0} do
{
	// Dynamic fading
	_stress	= vehicle player getVariable "stress";
	switch playerMood do
	{
		// ACE raises volume to 1
		case "tension":	{_volume	= ((0.5 - 25 / _stress) + (_stress - 50) / 200)};
		default			{_volume	= (0.5 - _stress / 100)};
	};
	3 fadeMusic _volume;

	// Play music if mood changes or last track is complete.
	MJBswitched	= false;
	if ((MJBpaused || (playerMood != _lastMood) || (time > (_lastPlay + _duration + 5))) && alive player) then
	{
		// Playing music
		if (MJBpaused) then
		{
			_resumeTime = pausedOn - _lastPlay;
		}
		else
		{
			// Selects a new track.
			while {MJBtrack == _lastTrack} do
			{
				scopeName "trackSelection";
				switch (playerMood) do
				{
					case "tension":
					{
						switch (count _tensionList) do	// prevents crashing
						{
							case 0:	{MJBtrack	= ""; breakOut "trackSelection"};
							case 1:	{_lastTrack = ""};
						};

						MJBtrack	= format["%1", _tensionList	select round(random (count _tensionList	- 1))];
					};
					case "truce":
					{
						switch (count _truceList) do
						{
							case 0:	{MJBtrack	= ""; breakOut "trackSelection"};
							case 1:	{_lastTrack = ""};
						};

						MJBtrack	= format["%1", _truceList	select round(random (count _truceList	- 1))];
					};
					case "darkness":
					{
						switch (count _darkList) do
						{
							case 0:	{MJBtrack	= ""; breakOut "trackSelection"};
							case 1:	{_lastTrack = ""};
						};

						MJBtrack	= format["%1", _darkList	select round(random (count _darkList	- 1))];
						if (count _darkList < 2) exitWith {_lastTrack = ""};
					};
				};
			};
			
			// Selects death scene track
			switch true do
			{
				case (count _sadList == 1):
				{
					sadTrack	= format["%1",_sadList	select 0];
				};
				case (count _sadList > 1):
				{
					while {(sadTrack == MJBtrack) || (sadTrack == "")} do
					{sadTrack	= format["%1",_sadList	select round(random (count _sadList	- 1))]};
				};
			};

			_lastTrack	= MJBtrack;
			_duration = getNumber (configFile >> "CfgMusic" >> MJBtrack >> "duration");
			_resumeTime = 0;
			_lastPlay = time;
			MJBswitched	= true;
		};
		playMusic [MJBtrack, _resumeTime];
		MJBpaused = false;
	};

	MJBtime	= time - _lastPlay;	// For display purposes
	_lastMood = playerMood;
	nul = [] execVM "scripts\MoodJukebox\display.sqf";
	sleep 0.5;
};
MJBon = false;